--------------------------------------------------------------------------------
--
-- LABORATORIO DE ARQUITECTURA DE COMPUTADORES
-- Paquete con funciones para tratamiento de ficheros.
--
-- 21.05.2007
--------------------------------------------------------------------------------
USE STD.textio.ALL;

PACKAGE file_pack1 IS
	-- Se declara un tipo array de tamao paramtrico de VECTOR_BUS de 28 bits.
	TYPE memoria_nx256 IS ARRAY (INTEGER RANGE <>) OF BIT_VECTOR (27 DOWNTO 0);

	-- Procedimiento para leer datos de un fichero ASCII y cargar la
	-- memoria.
	PROCEDURE cargar_rom(VARIABLE palabra: INOUT memoria_nx256;VARIABLE fichero_rom: IN text);
END file_pack1;

PACKAGE BODY file_pack1 IS
   PROCEDURE cargar_rom(VARIABLE palabra: INOUT memoria_nx256;VARIABLE fichero_rom: IN text) IS
      VARIABLE L: line;
      VARIABLE i: integer;
      BEGIN
	FOR i IN palabra'RANGE 
	LOOP
	   readline(fichero_rom, L);	-- devuelve un puntero LINE a STRING
	   read(L, palabra(i));		-- escribe el STRING sobre palabra(i)
	END LOOP;
      END cargar_rom;
END file_pack1;