USE STD.TEXTIO.ALL;
use WORK.ARQ_PACK.ALL;
USE WORK.file_pack1.ALL;

ENTITY rom256x28 IS
        GENERIC(retardo: TIME:=50 ns; nombre:STRING:="datos1.txt");
        PORT(direccion: IN BIT_VECTOR(7 DOWNTO 0):="00000000";
             me: IN BIT:='0';
             sal_datos: OUT bit_vector (27 DOWNTO 0));
END rom256x28;

ARCHITECTURE comportamiento OF rom256x28 IS
BEGIN
PROCESS
        VARIABLE pal: memoria_nx256(0 TO 255);
        VARIABLE comienzo: BOOLEAN:= TRUE;
        VARIABLE dir_log: BIT_VECTOR(7 DOWNTO 0);
        VARIABLE dir_ent: INTEGER;

        FILE fichero: TEXT IS nombre;

BEGIN
        WAIT ON direccion, me;

        IF comienzo THEN
               cargar_rom(pal, fichero);
               comienzo:=FALSE;
        END IF;

        IF(me='1') THEN
                                   
                dir_log:=direccion;
                logico_entero(dir_log, dir_ent);

                FOR i IN 0 TO 27 LOOP
                        IF pal(dir_ent)(i)='0' THEN
                                sal_datos(i)<=TRANSPORT '0' AFTER retardo;
                        ELSE
                                sal_datos(i)<=TRANSPORT '1' AFTER retardo;
                        END IF;
                END LOOP;
        END IF;

END PROCESS;
END comportamiento;

